From 4468ec9f0698ff6990e4d6922a6f5a0f0f73063b Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:35:09 +0000
Subject: [PATCH 957/1001] Hubs and widgets expose 'props' to the JS UI


---

diff --git a/hubs/models.py b/hubs/models.py
index 55530f9..3cc5850 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -299,6 +299,26 @@ class Hub(ObjectAuthzMixin, BASE):
             action = "{}.view".format(self.config.visibility)
         return "hub.{}".format(action)
 
+    def get_props(self):
+        """Get the hub properties for the Javascrip UI"""
+        roles = ["owner", "member"]
+        result = {
+            "name": self.name,
+            "config": self.config.__json__(),
+            "users": {role: [] for role in roles},
+            "mtime": self.last_refreshed,
+            "user_hub": self.user_hub,
+        }
+        for assoc in sorted(self.associations, key=lambda a: a.user.username):
+            if assoc.role not in roles:
+                continue
+            user = {
+                "username": assoc.user.username,
+                "fullname": assoc.user.fullname,
+            }
+            result["users"][assoc.role].append(user)
+        return result
+
     def __json__(self):
         return {
             'name': self.name,
@@ -458,6 +478,8 @@ class Widget(ObjectAuthzMixin, BASE):
     def module(self):
         return hubs.widgets.registry[self.plugin]
 
+    def get_props(self, with_secret_config=False):
+        return self.module.get_props(self, with_secret_config)
 
     @property
     def enabled(self):
diff --git a/hubs/tests/test_widget_base.py b/hubs/tests/test_widget_base.py
index 832c2f8..cb834d1 100644
--- a/hubs/tests/test_widget_base.py
+++ b/hubs/tests/test_widget_base.py
@@ -4,7 +4,7 @@ import six
 from mock import Mock
 
 from hubs.app import app
-from hubs.tests import APPTest
+from hubs.tests import APPTest, widget_instance
 from hubs.widgets.base import Widget
 from hubs.widgets.caching import CachedFunction
 from hubs.widgets.view import WidgetView
@@ -140,3 +140,28 @@ class WidgetTest(APPTest):
         rules = list(app.url_map.iter_rules(endpoint="testing_test2"))
         self.assertEqual(len(rules), 1)
         self.assertEqual(rules[0].rule, "/<hub>/w/testing/<int:idx>/test-2")
+
+    def test_get_props(self):
+        widget = widget_instance('ralph', "about")
+        with app.test_request_context('/'):
+            props = widget.get_props()
+        self.assertDictEqual(props, {
+            'config': {'text': 'Testing.'},
+            'contentUrl': '/ralph/w/about/{}/'.format(widget.idx),
+            'cssClass': None,
+            'hiddenIfEmpty': False,
+            'idx': widget.idx,
+            'index': 500,
+            'isReact': False,
+            'label': 'About',
+            'name': 'about',
+            'params': [
+                {'default': 'I am a Fedora user, and this is my about',
+                 'help': 'Text about a user.',
+                 'label': 'Text',
+                 'name': 'text'},
+            ],
+            'position': 'right',
+            'selfUrl': '/api/hubs/ralph/widgets/{}/'.format(widget.idx),
+            'title': 'About',
+        })
diff --git a/hubs/tests/widgets/test_halp.py b/hubs/tests/widgets/test_halp.py
index 5a489d3..f160993 100644
--- a/hubs/tests/widgets/test_halp.py
+++ b/hubs/tests/widgets/test_halp.py
@@ -117,6 +117,43 @@ class HalpViewsTestCase(WidgetTest):
     def test_view_authz(self):
         self._test_view_authz()
 
+    def test_props(self):
+        with app.test_request_context('/'):
+            props = self.widget.get_props()
+        self.assertDictEqual(props, {
+            'component': 'halp',
+            'config': {'hubs': ['fedora-devel'], 'per_page': 3},
+            'cssClass': None,
+            'hiddenIfEmpty': False,
+            'idx': self.widget.idx,
+            'index': 9,
+            'isReact': True,
+            'label': 'Help Requests',
+            'name': 'halp',
+            'params': [
+                {'default': [],
+                 'help': 'A comma-separated list of hubs to monitor.',
+                 'label': 'Hubs',
+                 'name': 'hubs',
+                 },
+                {'default': 4,
+                 'help': 'The number of requests per page to display.',
+                 'label': 'Requests per page',
+                 'name': 'per_page',
+                 },
+            ],
+            'position': 'right',
+            'selfUrl': '/api/hubs/ralph/widgets/{}/'.format(self.widget.idx),
+            'title': 'Help Requests',
+            'urls': {
+                'allHubs': '/w/halp/hubs',
+                'data': '/ralph/w/halp/{}/data'.format(self.widget.idx),
+                'requesters': '/ralph/w/halp/{}/requesters'.format(
+                    self.widget.idx),
+                'search': '/ralph/w/halp/{}/search'.format(self.widget.idx),
+            }
+        })
+
     def test_config_hubs_suggest(self):
         response = self.app.get('/w/halp/hubs')
         self.assertEqual(response.status_code, 200)
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 2dad1a1..5523385 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -36,9 +36,12 @@ class WidgetParameter(object):
             the parameter value to a JSON-serializable value, raising an
             exception if it is invalid.
         help (str): A help text that will be shown in the UI.
+        secret (bool): If True, this parameter will not be exposed to users
+            viewing the widget, it will only be available in the widget
+            configuration.
     """
 
-    _attrs = ('name', 'label', 'default', 'validator', 'help')
+    _attrs = ('name', 'label', 'default', 'validator', 'help', 'secret')
 
     def __init__(self, **kwargs):
         for name in self._attrs:
@@ -72,6 +75,7 @@ class Widget(object):
         cached_functions_module (list): The Python path to the module where the
             cached functions must be looked for.  By default, they are looked
             for in the same module.
+        is_react (bool): Set to True if the widget is React-based.
         hidden_if_empty (bool): Set to True if the widget box should be
             entirely hidden from the UI when no data is produced. As a
             consequence, there will also be no progress spinner when the widget
@@ -85,6 +89,7 @@ class Widget(object):
     parameters = []
     views_module = None
     cached_functions_module = None
+    is_react = False
     hidden_if_empty = False
 
     def __init__(self):
@@ -220,3 +225,62 @@ class Widget(object):
                 CachedFunction, self.cached_functions_module):
             result[fn_class.__name__] = fn_class
         return result
+
+    @property
+    def display_title(self):
+        """The title of the widget box in the UI."""
+        return self.label
+
+    def get_props(self, instance, with_secret_config=False):
+        """Generate the widget's properties for the Javascript UI.
+
+        Args:
+            instance (:py:class:`~hubs.models.Widget` or None): the widget
+                instance to generate the properties for. If None, only generate
+                the generic properties for this widget class.
+            with_secret_config (bool): include widget parameter values that are
+                marked as secret.
+
+        Returns:
+            dict: A dictionary that will be serialized to JSON
+        """
+        props = dict(
+            name=self.name,
+            label=self.label,
+            title=self.display_title,
+            position=self.position,
+            hiddenIfEmpty=self.hidden_if_empty,
+            cssClass=self.display_css,
+            isReact=self.is_react,
+            params=[],
+        )
+        for param in self.get_parameters():
+            param_data = dict(
+                name=param.name,
+                label=param.label,
+                default=param.default,
+                help=param.help,
+                )
+            props["params"].append(param_data)
+        if instance is not None:
+            props.update({
+                "idx": instance.idx,
+                "position": "left" if instance.left else "right",
+                "index": instance.index,
+                "selfUrl": flask.url_for(
+                    "api_hub_widget", hub=instance.hub.name, idx=instance.idx),
+                "config": {},
+            })
+            for param in self.get_parameters():
+                if param.secret and not with_secret_config:
+                    continue
+                value = param.validator(instance.config[param.name])
+                props["config"][param.name] = value
+            if self.is_react:
+                props["component"] = self.name
+            else:
+                props["contentUrl"] = flask.url_for(
+                    "%s_root" % self.name,
+                    hub=instance.hub.name,
+                    idx=instance.idx)
+        return props
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index f37ec2e..a9a265d 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -3,6 +3,8 @@ from __future__ import unicode_literals, absolute_import
 
 import logging
 
+import flask
+
 from hubs.feed import format_msgs
 from hubs.widgets import validators
 from hubs.widgets.base import Widget
@@ -28,6 +30,17 @@ class Feed(Widget):
             "help": "Max number of feed messages to display.",
         }]
     cached_functions_module = ".functions"
+    is_react = True
+
+    def get_props(self, instance, *args, **kwargs):
+        props = super(Feed, self).get_props(instance, *args, **kwargs)
+        if instance is not None:
+            hub_name = instance.hub.name
+            props.update(dict(
+                url=flask.url_for(
+                    "feed_existing", hub=hub_name, idx=instance.idx),
+                ))
+        return props
 
 
 class BaseView(RootWidgetView):
diff --git a/hubs/widgets/halp/__init__.py b/hubs/widgets/halp/__init__.py
index 741b1e6..8fc82d4 100644
--- a/hubs/widgets/halp/__init__.py
+++ b/hubs/widgets/halp/__init__.py
@@ -37,6 +37,7 @@ class Halp(Widget):
         )]
     views_module = ".views"
     cached_functions_module = ".functions"
+    is_react = True
 
     def get_template_environment(self):
         env = super(Halp, self).get_template_environment()
@@ -49,3 +50,20 @@ class Halp(Widget):
         rule = "/w/%s/hubs" % self.name
         endpoint = "%s_config_hubs" % self.name
         app.add_url_rule(rule, endpoint=endpoint, view_func=hubs_suggest_view)
+
+    def get_props(self, instance, *args, **kwargs):
+        props = super(Halp, self).get_props(instance, *args, **kwargs)
+        props["urls"] = dict(
+            allHubs=flask.url_for("halp_config_hubs"),
+        )
+        if instance is not None:
+            hub_name = instance.hub.name
+            props["urls"].update(dict(
+                data=flask.url_for(
+                    "halp_data", hub=hub_name, idx=instance.idx),
+                search=flask.url_for(
+                    "halp_search", hub=hub_name, idx=instance.idx),
+                requesters=flask.url_for(
+                    "halp_requesters", hub=hub_name, idx=instance.idx),
+                ))
+        return props

